function f = cmd(x0,gammahat,indx,theta,W);

theta.value(theta.estimation==1) = x0;
alpha = theta.value(1);
kappa = theta.value(2);
sigma = theta.value(3);
zeta  = theta.value(4);
if theta.estimation(1)==1
    kappa = (1-alpha)*(1-0.99*alpha)*zeta/alpha;
end

g = [1+sigma*sigma;kappa+sigma*sigma*kappa;-sigma;1+kappa*kappa+sigma*sigma*kappa*kappa;-kappa*sigma];
g = g(indx==1);
f = (1/2)*(gammahat-g)'*W*(gammahat-g);

