function f = cmd3(sigma,kappa);
load temp;
m = size(sigma,1);
n = size(sigma,2);
f = zeros(m,n);
for i=1:m
    for j=1:n
        s = sigma(i,j);
        k = kappa(i,j);
        g = [k+s*s*k;1+k*k+s*s*k*k;-k*s];
        f(i,j) = exp(-(1/2)*(gammahat-g)'*W*(gammahat-g));
    end
end
