function logGELBF = gelbf(indx,options,theta,x0,y)

options_gel=optimoptions(@fminunc,'Algorithm','quasi-newton','HessUpdate','bfgs','Display','none');

q = Inf;
while q==Inf    
    try
        [x,q] = fminunc('gel',x0+randn(size(x0)),options,indx,options_gel,theta,y);
    catch 
        continue
    end
end
logGELBF = -q+0.5*(sum(indx)-length(x0))*log(size(y,1)); 
