
% A: mean, B: std
n_sim=number_of_draw;
para_pri_draw=zeros(n_sim,6);

%% omega
A_o=para_pri(1,1);
B_o=para_pri(1,2);

%% lambda
A_l=para_pri(2,1);
B_l=para_pri(2,2);

%% Pistar
A_p=para_pri(3,1);
B_p=para_pri(3,2);

%% theta
A_t=para_pri(4,1);
B_t=para_pri(4,2);

%% alpha
A_a=para_pri(5,1);
B_a=para_pri(5,2);

%% beta
A_b=para_pri(6,1);
B_b=para_pri(6,2);

%{
%% rho
A_r=para_pri(6,1);
B_r=para_pri(6,2);
%}

%% draw random variable for each parameter

n_draw=n_sim;
counter=0;
while n_draw>0
% omega
if para_estim(1)==1
    omega_pri=random('beta',A_o^2*(1-A_o)/B_o^2-A_o,(1-A_o)/A_o*(A_o^2*(1-A_o)/B_o^2-A_o),n_draw,1);
    %omega=1-1./(1+random('gamma',A^2*(1-A)/B^2-A,(1-A)/A*(A^2*(1-A)/B^2-A),1,1));
else
    omega_pri=ones(n_draw,1)*para_fix(1);
end

% lambda
if para_estim(2)==1
    lambda_pri=random('beta',A_l^2*(1-A_l)/B_l^2-A_l,(1-A_l)/A_l*(A_l^2*(1-A_l)/B_l^2-A_l),n_draw,1);
else
    lambda_pri=ones(n_draw,1)*para_fix(2);
end

% Pistar
if para_estim(3)==1
    Pistar1_pri=random('norm', A_p,B_p,n_draw,1);
else
    Pistar1_pri=ones(n_draw,1)*para_fix(3);
end

% theta
if para_estim(4)==1
    theta_pri=random('gam',A_t^2/B_t^2,B_t^2/A_t,n_draw,1 );
else
    theta_pri=ones(n_draw,1)*para_fix(4);
end

% alpha
if para_estim(5)==1
    alpha_pri=random('beta',A_a^2*(1-A_a)/B_a^2-A_a,(1-A_a)/A_a*(A_a^2*(1-A_a)/B_a^2-A_a),n_draw,1);
else
    alpha_pri=ones(n_draw,1)*para_fix(5);
end

% beta
if para_estim(6)==1
    beta_pri=(random('gam',A_b^2/B_b^2,B_b^2/A_b,n_draw,1 )/100+1).^(-1);
else
    beta_pri=ones(n_draw,1)*para_fix(6);
end


%% violation check
if (model==2)
    para_pri_draw=[omega_pri, lambda_pri, Pistar1_pri,theta_pri,alpha_pri,beta_pri];
    n_draw=0;
else
    draw=[omega_pri, lambda_pri, Pistar1_pri,theta_pri,alpha_pri,beta_pri];
    
    assumption1=beta_pri.*lambda_pri.*(1+Pistar1_pri/100).^(theta_pri-1);
    assumption2=beta_pri.*lambda_pri.*(1+Pistar1_pri/100).^(theta_pri./alpha_pri);
    
    violation=(assumption1>=1)+(assumption2>=1);
    n_alive=sum(violation==0);
    para_non_violate=reshape(draw(repmat(violation,[1,6])==0),[n_alive,6]);
    para_pri_draw(counter+1:counter+n_alive,:)=para_non_violate;
    counter=counter+n_alive;
    n_draw=n_sim-counter;

end    
end

