%clear all

%% save excel file
prior_mat=zeros(size(prior_set,1)+5,7,5);
for_graph=zeros(M,3,10,2);
J_mat=zeros(5); % add 2017/12/3
%para_estim_extended=[para_estim0(3);para_estim0(2);para_estim0(1);para_estim0(4:6);ones(2,1)];

%reduced_savefile=[today,'reducedformcoef_',num2str(num),'.xlsx'];
reduced_savefile=[pwd(),'\',today1,'\',today,'reducedformcoef_',num2str(num),'.xlsx'];

if excel_output==1
copyfile('(format)reduced_form_coef.xlsx',reduced_savefile)
end

m1=start_estim_model;
m2=end_estim_model;
s1=start_estim_period;
s2=end_estim_period;

posterior_mean=zeros(size(prior_set,1)+5,s2-s1+1,m2-m1+1);
posterior_CI90lower=zeros(size(prior_set,1)+5,s2-s1+1,m2-m1+1);
posterior_CI90upper=zeros(size(prior_set,1)+5,s2-s1+1,m2-m1+1);
Jstat=zeros(1,s2-s1+1,m2-m1+1); % add 2017/12/3

for mmm=m1:m2 % model
post_means=[];

for ss=s1:s2 % sample period
 loadfile=[savefile_root,'_',num2str(num),'_model',num2str(mmm),'_sample',num2str(ss),'.mat'];
 load(loadfile)

% adjust old data for present codes
%reduced_savefile=[today,'reducedformcoef_',num2str(num),'.xlsx'];
reduced_savefile=[pwd(),'\',today1,'\',today,'reducedformcoef_',num2str(num),'.xlsx'];

%clear para_ss
%para_s=[omega, lambda,Pistar1,theta,alpha,beta];
para_s=para_s(:,1:6);

kappa_prior

% prior
prior_mat(:,1:2,ss)=...
[ para_pri(3,:)*4;
  para_pri(2,:);
  para_pri(1,:);
  para_pri(4,:);
  para_pri(5,:);
  para_pri(6,:);
  mean(slope_pri), std(slope_pri);
  mean(gamma_b_pri), std(gamma_b_pri);
  mean(kappa_f_pri), std(kappa_f_pri);
  mean(kappa_d_pri), std(kappa_d_pri);
  mean(gamma_f_pri), std(gamma_f_pri)];


lower_CI=0.16; % or 0.1
upper_CI=0.84; % or 0.9
lower_CI90=0.05;
upper_CI90=0.95;

sorted=sort(omega_post);
CI_omega(1)=sorted(length(sorted)*lower_CI90,1);
CI_omega(2)=sorted(length(sorted)*upper_CI90,1);
CI_omega(3)=sorted(length(sorted)*lower_CI,1);
CI_omega(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort(lambda_post);
CI_lambda(1)=sorted(length(sorted)*lower_CI90,1);
CI_lambda(2)=sorted(length(sorted)*upper_CI90,1);
CI_lambda(3)=sorted(length(sorted)*lower_CI,1);
CI_lambda(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort((Pistar_post-1)*400);
CI_400log_pi(1)=sorted(length(sorted)*lower_CI90,1);
CI_400log_pi(2)=sorted(length(sorted)*upper_CI90,1);
CI_400log_pi(3)=sorted(length(sorted)*lower_CI,1);
CI_400log_pi(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort(theta_post);
CI_theta(1)=sorted(length(sorted)*lower_CI90,1);
CI_theta(2)=sorted(length(sorted)*upper_CI90,1);
CI_theta(3)=sorted(length(sorted)*lower_CI,1);
CI_theta(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort(alpha_post);
CI_alpha(1)=sorted(length(sorted)*lower_CI90,1);
CI_alpha(2)=sorted(length(sorted)*upper_CI90,1);
CI_alpha(3)=sorted(length(sorted)*lower_CI,1);
CI_alpha(4)=sorted(length(sorted)*upper_CI,1);


sorted=sort(beta_post);
CI_beta(1)=sorted(length(sorted)*lower_CI90,1);
CI_beta(2)=sorted(length(sorted)*upper_CI90,1);
CI_beta(3)=sorted(length(sorted)*lower_CI,1);
CI_beta(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort(gamma_b);
CI_gamma_b(1)=sorted(length(sorted)*lower_CI90,1);
CI_gamma_b(2)=sorted(length(sorted)*upper_CI90,1);
CI_gamma_b(3)=sorted(length(sorted)*lower_CI,1);
CI_gamma_b(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort(gamma_f);
CI_gamma_f(1)=sorted(length(sorted)*lower_CI90,1);
CI_gamma_f(2)=sorted(length(sorted)*upper_CI90,1);
CI_gamma_f(3)=sorted(length(sorted)*lower_CI,1);
CI_gamma_f(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort(slope);
CI_slope(1)=sorted(length(sorted)*lower_CI90,1);
CI_slope(2)=sorted(length(sorted)*upper_CI90,1);
CI_slope(3)=sorted(length(sorted)*lower_CI,1);
CI_slope(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort(kappa_f);
CI_kappa_f(1)=sorted(length(sorted)*lower_CI90,1);
CI_kappa_f(2)=sorted(length(sorted)*upper_CI90,1);
CI_kappa_f(3)=sorted(length(sorted)*lower_CI,1);
CI_kappa_f(4)=sorted(length(sorted)*upper_CI,1);

sorted=sort(kappa_d);
CI_kappa_d(1)=sorted(length(sorted)*lower_CI90,1);
CI_kappa_d(2)=sorted(length(sorted)*upper_CI90,1);
CI_kappa_d(3)=sorted(length(sorted)*lower_CI,1);
CI_kappa_d(4)=sorted(length(sorted)*upper_CI,1);

if model==2||model==4||model==6||model==8
CI_kappa_f(1)=0;
CI_kappa_f(2)=0;
CI_kappa_f(3)=0;
CI_kappa_f(4)=0;
end

if model==3||model==7
CI_kappa_d(1)=0;
CI_kappa_d(2)=0;
CI_kappa_d(3)=0;
CI_kappa_d(4)=0;
end

prior_mat(:,3:7,ss)=...
[ mean((Pistar_post-1)*400),CI_400log_pi;  
  mean(lambda_post),CI_lambda;
  mean(omega_post),CI_omega;
  mean(theta_post),CI_theta;
  mean(alpha_post),CI_alpha;
  mean(beta_post),CI_beta;
  mean(slope)  , CI_slope;
  mean(gamma_b), CI_gamma_b;
  mean(kappa_f), CI_kappa_f;
  mean(kappa_d), CI_kappa_d;
  mean(gamma_f), CI_gamma_f];

%post_mean=mean([omega_post,lambda_post,Pistar_post*100-1*100,theta_post,alpha_post,beta_post]); % add 2017/12/3

if ss==1
    area_coef='C5:I14';
    name_posi='B2';
elseif ss==2
    area_coef='C19:I28';
    name_posi='B16';
elseif ss==3
    area_coef='C33:I42';
    name_posi='B30';
elseif ss==4
    area_coef='C47:I56';
    name_posi='B44';
elseif ss==5
    area_coef='C61:I70';
    name_posi='B58';
elseif ss==6
    area_coef='C75:I84';
    name_posi='B72';
end


if mmm==1
    sheetname='GNKPC';
elseif mmm==2
    sheetname='NKPC';
elseif mmm==3
    sheetname='CogleySbordone';
end

if excel_output==1
xlswrite(reduced_savefile,prior_mat(:,:,ss),sheetname,area_coef)
xlswrite(reduced_savefile,{period_name},sheetname,name_posi)
xlswrite(reduced_savefile,{country},sheetname,'A1')
xlswrite(reduced_savefile,{CPIorDEFLATOR;denomi_type;NW;GMMmethod},sheetname,'J1:J4')
xlswrite(reduced_savefile,{['IV:',char(IV)]},sheetname,'A71')
xlswrite(reduced_savefile,{[today,'reducedformcoef_',num2str(num),'.xlsx']},sheetname,'D1')
end

for_graph(:,ss,3,mmm)=omega_post;
for_graph(:,ss,2,mmm)=lambda_post;
for_graph(:,ss,1,mmm)=(Pistar_post-1)*400;

for_graph(:,ss,4,mmm)=theta_post;
for_graph(:,ss,5,mmm)=alpha_post;
for_graph(:,ss,6,mmm)=beta_post;

for_graph(:,ss,7,mmm)=slope;
for_graph(:,ss,8,mmm)=gamma_b;
for_graph(:,ss,9,mmm)=gamma_f;
for_graph(:,ss,10,mmm)=kappa_f;

% add 2017/12/3
%J_mat(ss)=-2*lik_GMM(Y,X,Z,post_mean,para_fix,model,denominator,NWlags,para_estim);

[negative_Lmode,xhat,ghat,Hhat,itct,fcount,retcodehat] = ... 
csminwel(@(para)-lik_GMM(Y,X,Z,para,para_fix,model,denominator,NWlags,para_estim),para_ini(para_estim==1),eye(length(para_ini(para_estim==1))),[] ,1e-14,100);
J_mat(ss)=2*negative_Lmode;
% end add 2017/12/3


end



pri_means=[];
pri_stds=[]; % add 2017/12/03
post_means=[];
post_CI90lowers=[];
post_CI90uppers=[];
Jstats=[]; % add 2017/12/03
for ncolumn=s1:s2
    pri_means=[pri_means,prior_mat(:,1,ncolumn)];
    pri_stds=[pri_stds,prior_mat(:,2,ncolumn)]; % add 2017/12/03
    post_means=[post_means,prior_mat(:,3,ncolumn)];
    post_CI90lowers=[post_CI90lowers,prior_mat(:,4,ncolumn)];
    post_CI90uppers=[post_CI90uppers,prior_mat(:,5,ncolumn)];
    Jstats=[Jstats,J_mat(ncolumn)]; % add 2017/12/3
end
    prior_mean(:,:,mmm)=pri_means;
    prior_std(:,:,mmm)=pri_stds; % add 2017/12/03
    posterior_mean(:,:,mmm)=post_means;
    posterior_CI90lower(:,:,mmm)=post_CI90lowers;
    posterior_CI90upper(:,:,mmm)=post_CI90uppers;
    Jstat(:,:,mmm)=Jstats; % add 2017/12/3
end

if graphing==1
%% plot posteriors

% graphs for paper
tate=1;
plot_posteriors;

% graphs for presentation slide
tate=0;
plot_posteriors;
else
end
