function f = gel(x0,indx,options,theta,y);

theta.value(theta.estimation==1) = x0;
alpha = theta.value(1);
kappa = theta.value(2);
sigma = theta.value(3);
zeta  = theta.value(4);
if theta.estimation(1)==1
    kappa = (1-alpha)*(1-0.99*alpha)*zeta/alpha;
end

g = [1+sigma*sigma;kappa+sigma*sigma*kappa;-sigma;1+kappa*kappa+sigma*sigma*kappa*kappa;-kappa*sigma];
gamma = [y(:,1).*y(:,1) y(:,2).*y(:,1) y(:,3).*y(:,1) y(:,2).*y(:,2) y(:,3).*y(:,2)];
g = g(indx==1);
gamma = gamma(:,indx==1);
m = gamma-ones(size(y,1),1)*g';

lambda0 = zeros(sum(indx),1);
lambda = fminunc(@(lambda) sum(exp(m*lambda)),lambda0,options);
f = -sum(exp(m*lambda));

