function [M]=GMM1stStep(Y,X,Z,para2,para_fix,model,denominator,para_estim,para_pri,NWlags,iniWM)

[Zu]=cal_moment(Y,X,Z,para2,para_fix,model,denominator,para_estim);
T=size(Zu,1);
g=sum(Zu,1)'/T;

% matform
% =1 if using 'EYE' matrix for 1st step weighting matrix 
% =0 if using 'instrument*instrument' matrix for 1st step WM
% =-1 if using demeaned 'instrument*instrument' matrix.

if iniWM==1
    %M=T*0.5*(g'*g)-prior(para2,para_pri);
    M=T*0.5*(g'*g);
elseif iniWM==0
    %ZZ=[Z.Z1,Z.Z2]; 
    %[W, Shat]=weighting_mat(ZZ,NWlags);
    
    %M=T*0.5*(g'/Shat*g)-prior(para2,para_pri);
    %M=T*0.5*(g'/Shat*g);
    if length(Z.Z2)==0;
        W=inv(Z.Z1'*Z.Z1);
    else
        W= [inv(Z.Z1'*Z.Z1), zeros(size(Z.Z1,2),size(Z.Z2,2));   % W= ( inv(Z1fZ1)@     0     )
            zeros(size(Z.Z2,2),size(Z.Z1,2)), inv(Z.Z2'*Z.Z2)];  %    (     0@     inv(Z2fZ2) )
    end
    M=T*0.5*(g'*W*g);
elseif iniWM==-1
    ZZ=[Z.Z1,Z.Z2];
    ZZbar=repmat(mean(ZZ,1),size(ZZ,1),1);
    [W, Shat]=weighting_mat(ZZ-ZZbar,NWlags);
    M=T*0.5*(g'/Shat*g);
end




% if (para2(1)<0)||(para2(1)>1)
%     M=Inf;
% end
% if (para2(2)<0)||(para2(2)>1)
%     M=Inf;
% end
% if (para2(4)<1)
%     M=Inf;
% end
end