function [W,LAMBDA,para]=TwoStepGMM_WM(Y,X,Z,para_fix,model,denominator,NWlags,para_estim,para_ini,para_pri,iniWM)

%% first step estimator
[fhat,xhat,ghat,Hhat,itct,fcount,retcodehat] = ... 
 csminwel(@(para2)GMM1stStep(Y,X,Z,para2,para_fix,model,denominator,para_estim,para_pri,NWlags,iniWM),para_ini,eye(length(para_ini)),[] ,1e-14,100);
%[xhat,fval,exitflag,output,grad,hessian] = ...
% fminunc(@(para2)GMM1stStep(Y,X,Z,para2,para_fix,model,denominator,para_estim,NWlags,iniWM),para_ini);
 para=xhat
para(para_estim==0)=para_fix(para_estim==0); 

%% moment based on 1st step estimator 
[Zu]=cal_moment(Y,X,Z,para,para_fix,model,denominator,para_estim);

%% weighting matrix
[W, LAMBDA]=weighting_mat(Zu,NWlags);

end

% function [M]=GMM1stStep(Y,X,Z,para2,para_fix,model,denominator,para_estim)
% 
% [Zu]=cal_moment(Y,X,Z,para2,para_fix,model,denominator,para_estim);
% T=size(Zu,1);
% g=sum(Zu,1)'/T;
% 
% M=0.5*(g'*g); 
% end

