function [L,M,W]=lik_GMM(Y,X,Z,para,para_fix,model,denominator,NWlags,para_estim)


[Zu]=cal_moment(Y,X,Z,para,para_fix,model,denominator,para_estim);
T=size(Zu,1);
%% weighting matrix

% for 2-step GMM
if Z.TSGMM==1
    W=Z.W;
    LAMBDA=Z.LAMBDA;
% for Continuous-Updating GMM
else
    [W, LAMBDA]=weighting_mat(Zu,NWlags);
end

%% moment condition
%{
ut2=zeros(size(ut,1),size(Z,2));
for k=1:size(Z,2)
    ut2(:,k)=ut;
end
%}
%ut2=repmat(ut,1,n_inst);

%g=sum(Z.*ut2,1)'/T;
g=sum(Zu,1)'/T;

% M=g'/LAMBDA*g; 
M=0.5*g'*W*g; 
%M=0.5*g'*eye(n_inst)*g; 


%L=-0.5*n_inst*log(2*pi/T)-T*M+0.5*log(det(W));
L=-T*M;
%L=0.5*log(det(W));
%L=-0.5*size(Z,2)*log(2*pi/size(Z,1))-0.5*M+0.5*log(det(W));

if violation_check(para,para_fix,para_estim)==1
    L=-Inf;
end
    
if isnan(rcond(W))==1
    L=-Inf;
end

end

