m1=start_estim_model;
m2=end_estim_model;
s1=start_estim_period;
s2=end_estim_period;

HMbox=zeros(9,2);

LAP_s=zeros(s2-s1+1,m2-m1+1);
LAPp_s=zeros(s2-s1+1,m2-m1+1);
HM2_s=zeros(s2-s1+1,m2-m1+1);
HM5_s=zeros(s2-s1+1,m2-m1+1);
HM9_s=zeros(s2-s1+1,m2-m1+1);
SWZ5_s=zeros(s2-s1+1,m2-m1+1);
SWZ9_s=zeros(s2-s1+1,m2-m1+1);
CJalt_s=zeros(s2-s1+1,m2-m1+1);

MLAP_s=zeros(s2-s1+1,m2-m1+1);
MLAPp_s=zeros(s2-s1+1,m2-m1+1);
MHM2_s=zeros(s2-s1+1,m2-m1+1);
MHM5_s=zeros(s2-s1+1,m2-m1+1);
MHM9_s=zeros(s2-s1+1,m2-m1+1);
MSWZ5_s=zeros(s2-s1+1,m2-m1+1);
MSWZ9_s=zeros(s2-s1+1,m2-m1+1);
MCJalt_s=zeros(s2-s1+1,m2-m1+1);

fr=1;
qq=[];
count_m=1;

for mmm=m1:m2 % model
count_s=1;
names=[];
for sss=s1:s2 % sample period

loadfile=[savefile_root,'_',num2str(num),'_model',num2str(mmm),'_sample',num2str(sss),'.mat'];
load(loadfile)

names=[names, ' | ', period_name];


para_s(:,3)=para_s(:,3)/400; % change unit from annual(%) to quarterly(-)
num_mcmc=size(para_s,1);
para_s2=[];

for jj=1:6
    if para_estim(jj)==1
        para_s2=[para_s2,para_s(:,jj)];
    end
end
cov_para=cov(para_s2,1);
m_para=mean(para_s,1);
m_para2=mean(para_s2,1);

mod_para2=paramod;
mod_para2(3)=mod_para2(3)/400;
mod_para2=mod_para2(para_estim==1)';
m_lnL_lnp=mean(loglike_s+logpri_s);
mod_lnL_lnp=-negative_Lmode;

SIGMAhat=(para_s2-repmat(mod_para2,size(para_s2,1),1))'*(para_s2-repmat(mod_para2,size(para_s2,1),1))/size(para_s2,1);


% evaluating likelihood function with posterior mean
para=zeros(6,1);
para(para_estim==1)=m_para(para_estim==1)';
para(para_estim==0)=para_fix(para_estim==0);
[Lmean,Mmean,Wmean]=lik_GMM(Y,X,Z,para,para_fix,mmm,denominator,NWlags,para_estim);
ln_p_mean=prior(m_para',para_pri);

% HM=0;
HM2=0;
CJ2=0;
num_alt=0;

T=size(Z.Z1,1);

number_para=sum(para_estim);

%% Laplace approximation
%(way 1) use mode and hessian which minimize moment condition 
% [minM,xhat,ghat,Hhat,itct,fcount,retcodehat] = ... 
%     csminwel(@(para)moment_condition(Y,X,Z,para,para_fix,mmm,denominator,NWlags,para_estim),para_ini(para_estim==1),eye(length(para_ini(para_estim==1))),[] ,1e-14,50);
% para2=para_fix;
% para2(para_estim==1)=xhat;
% ln_p=prior(para2,para_pri);
% % LAP = -T*minM - number_para/2*log(det(T/(2*pi)))-0.5*log(det(inv(Hhat))) + ln_p;
% 
% LAP_s(count_s,count_m)=LAP;
% MLAP_s(count_s,count_m)=LAP-(1-1/sqrt(T))*(-negative_Lmode-prior(paramod,para_pri)); 

% %(way 3) use mode and hessian which maximizes posterior density
LAPp = -negative_Lmode + number_para/2*log(2*pi/T) - 0.5*log(det( (inv(hess))));

LAPp_s(count_s,count_m)=LAPp;
MLAPp_s(count_s,count_m)=LAPp-(1-1/sqrt(T))*(-negative_Lmode-prior(paramod,para_pri)); 


%% Harmonic mean estimator

p9=0.1;
p5=0.5;


if num_mcmc*fr<=10000
    q  =diag((para_s2(1:end*fr,:)-repmat(m_para2  ,num_mcmc*fr,1))/(cov_para)*(para_s2(1:end*fr,:)-repmat(m_para2  ,num_mcmc*fr,1))');
    qCJ=diag((para_s2(1:end*fr,:)-repmat(mod_para2,num_mcmc*fr,1))   /hess   *(para_s2(1:end*fr,:)-repmat(mod_para2,num_mcmc*fr,1))');
    qSWZ=diag((para_s2(1:end*fr,:)-repmat(mod_para2,num_mcmc*fr,1))   /SIGMAhat   *(para_s2(1:end*fr,:)-repmat(mod_para2,num_mcmc*fr,1))');

else
    q=[];
    qCJ=[];
    qSWZ=[];
    num_block=(num_mcmc*fr - mod(num_mcmc*fr,10000))/10000;
    for mmcc=1: num_block
        q_temp  =diag( (para_s2(10000*(mmcc-1)+1:10000*mmcc,:)-repmat(m_para2  ,10000,1))/(cov_para)*(para_s2(10000*(mmcc-1)+1:10000*mmcc,:)-repmat(m_para2  ,10000,1))'  );
        q=  [q;q_temp];
        qCJ_temp=diag( (para_s2(10000*(mmcc-1)+1:10000*mmcc,:)-repmat(mod_para2,10000,1))   /hess   *(para_s2(10000*(mmcc-1)+1:10000*mmcc,:)-repmat(mod_para2,10000,1))'  );
        qCJ=[qCJ;qCJ_temp];
        qSWZ_temp=diag( (para_s2(10000*(mmcc-1)+1:10000*mmcc,:)-repmat(mod_para2,10000,1))   /SIGMAhat   *(para_s2(10000*(mmcc-1)+1:10000*mmcc,:)-repmat(mod_para2,10000,1))'  );
        qSWZ=[qSWZ;qSWZ_temp];
    end
    q_temp  =diag( (para_s2(10000*num_block+1:num_mcmc*fr,:)-repmat(m_para2  ,mod(num_mcmc*fr,10000),1))/(cov_para)*(para_s2(10000*num_block+1:num_mcmc*fr,:)-repmat(m_para2  ,mod(num_mcmc*fr,10000),1))'  );
    q=  [q;q_temp];
    qCJ_temp=diag( (para_s2(10000*num_block+1:num_mcmc*fr,:)-repmat(mod_para2,mod(num_mcmc*fr,10000),1))   /hess   *(para_s2(10000*num_block+1:num_mcmc*fr,:)-repmat(mod_para2,mod(num_mcmc*fr,10000),1))'  );
    qCJ=[qCJ;qCJ_temp];
    qSWZ_temp=diag( (para_s2(10000*num_block+1:num_mcmc*fr,:)-repmat(mod_para2,mod(num_mcmc*fr,10000),1))   /SIGMAhat   *(para_s2(10000*num_block+1:num_mcmc*fr,:)-repmat(mod_para2,mod(num_mcmc*fr,10000),1))'  );
    qSWZ=[qSWZ;qSWZ_temp];
end
        ln_w5=-log(1-p5)-number_para/2*log(2*pi)-0.5*log(det(cov_para))-q/2;
        
        ln_L=loglike_s;
        ln_p=logpri_s;    
        temp=ln_w5-ln_L(1:end*fr,:)-ln_p(1:end*fr,:)+m_lnL_lnp;
       
        temp=exp(temp);
        temp(q>=repmat(chi2inv(1-p5,number_para),num_mcmc*fr,1))=0;
        
        HM5=sum(temp);
        
        HM5=HM5/num_mcmc/exp(m_lnL_lnp);
        HM5=log((HM5)^(-1));
 
HM5_s(count_s,count_m) =HM5;
MHM5_s(count_s,count_m) =HM5-(1-1/sqrt(T))*(-negative_Lmode-prior(paramod,para_pri));

        ln_w9=-log(1-p9)-number_para/2*log(2*pi)-0.5*log(det(cov_para))-q/2;
        ln_L=loglike_s;
        ln_p=logpri_s;    
        temp=ln_w9-ln_L(1:end*fr,:)-ln_p(1:end*fr,:)+m_lnL_lnp;
        temp=exp(temp);
        temp(q>=repmat(chi2inv(1-p9,number_para),num_mcmc*fr,1))=0;
        HM9=sum(temp);       

        HM9=HM9/num_mcmc/exp(m_lnL_lnp);
        HM9=log((HM9)^(-1));
  
HM9_s(count_s,count_m)=HM9;
MHM9_s(count_s,count_m)=HM9-(1-1/sqrt(T))*(-negative_Lmode-prior(paramod,para_pri));

%% Sims, Waggoner and Zha

N     = num_mcmc; %num_mcmc=size(para_s,1);
d = number_para;
Sigmahat = SIGMAhat; %cov_para; 
logpost_s = loglike_s + logpri_s;
MCMC = [logpost_s para_s2];
xmean    = m_para2; %m_para2=mean(para_s2,1);

r = qSWZ;
r   = sqrt(r);
sortedr = sort(r);
c1  = sortedr(floor(0.01*N)+1,1);
c10 = sortedr(floor(0.10*N)+1,1);
c90 = sortedr(floor(0.90*N)+1,1);
nu  = log(0.1/0.9)/log(c10/c90);
a   = c1;
b   = c90/0.9^(1/nu);
g   = nu*r.^(nu-1)/(b^nu-a^nu);
ftilde = gamma(d/2)*g./(2*pi^(d/2)*sqrt(det(Sigmahat))*r.^(d-1));
sortedL = sort(MCMC(:,1));
L5  = sortedL(floor(0.5*N)+1,1);
L9  = sortedL(floor(0.1*N)+1,1);
indx9  = (MCMC(:,1)>L9)&(r>=a)&(r<=b);
indx5  = (MCMC(:,1)>L5)&indx9; 
SWZ9 = sum(ftilde(indx9,1).*exp(-MCMC(indx9,1)));
SWZ5 = sum(ftilde(indx5,1).*exp(-MCMC(indx5,1)));
[L,D]=ldl(Sigmahat);
D = diag(D);
D(D<sqrt(eps))=sqrt(eps);
P = L*sqrt(diag(D));
u = rand(N,1);
r = (a^nu+(b^nu-a^nu)*u).^(1/nu);
z = randn(N,d);
s = r./sqrt(sum(z.*z,2));
x = ones(N,1)*xmean+(s*ones(1,d)).*z*P';

tauhat5 = 0;
tauhat9 = 0;

for j=1:N
    try
        %L = -cmd(x(j,:),gammahat,indx,theta,W); 
        
        q  = (para_s2(j,:)-mod_para2)/(Sigmahat)*(para_s2(j,:)-mod_para2)';
        L = -q;
    catch
        continue
    end
    if L>L9
        tauhat9 = tauhat9+1;
        if L>L5
            tauhat5 = tauhat5+1;
        end
    end
end
SWZ5 = -log(SWZ5/tauhat5);
SWZ9 = -log(SWZ9/tauhat9);

SWZ5_s(count_s,count_m)=SWZ5;
MSWZ5_s(count_s,count_m)=SWZ5-(1-1/sqrt(T))*(-negative_Lmode-prior(paramod,para_pri));

SWZ9_s(count_s,count_m)=SWZ9;
MSWZ9_s(count_s,count_m)=SWZ9-(1-1/sqrt(T))*(-negative_Lmode-prior(paramod,para_pri));


%% Chib-Jeliazkov estimator 

%% (way1) using posterior mode as arbitary point
temp3=min( [exp(mod_lnL_lnp-ln_L(1:end*fr,1)-ln_p(1:end*fr,1)),ones(fr*num_mcmc,1)]')'.*exp(-qCJ/2);
num_alt=sum(temp3);
%num_alt=num_alt/sqrt((2*pi/T)^(number_para)*det(hess));
num_alt=num_alt*(2*pi/T)^(-number_para/2)*det(hess)^(-0.5);
den =0;
[S_hess,V_hess,D_hess]=svd(hess);
for ii=1:fr*num_mcmc
x=paramod;
x(para_estim==1)=paramod(para_estim==1) + S_hess*V_hess^0.5 * randn(size(hess,1),1);
%x(para_estim==1)=paramod(para_estim==1) + chol(hess) * randn(size(hess,1),1);
%x(para_estim==1)=paramod(para_estim==1) + mvnrnd(zeros(1,size(para_ini(para_estim==1),1)),hess)';
L1=lik_GMM(Y,X,Z,x,para_fix,mmm,denominator,NWlags,para_estim)+prior(x,para_pri);
den=den+min(exp(L1-mod_lnL_lnp),1);

end
CJalt=mod_lnL_lnp-log(num_alt/den);

% % (way2) using posterior mean as arbitary point
% temp3=min( [exp(m_lnL_lnp-ln_L(1:end*fr,1)-ln_p(1:end*fr,1)),ones(fr*num_mcmc,1)]')'.*exp(-q/2+mean(q/2));
% num_alt=sum(temp3);
% %num_alt=num_alt/sqrt((2*pi)^(number_para)*det(hess));
% num_alt=num_alt*(2*pi)^(-number_para/2)*det(cov_para)^(-0.5);
% den =0;
% [S_hess,V_hess,D_hess]=svd(cov_para);
% for ii=1:fr*num_mcmc
% x=m_para';
% x(para_estim==1)=m_para2' + S_hess*V_hess^0.5 * randn(size(hess,1),1);
% %x(para_estim==1)=paramod(para_estim==1) + chol(hess) * randn(size(hess,1),1);
% %x(para_estim==1)=paramod(para_estim==1) + mvnrnd(zeros(1,size(para_ini(para_estim==1),1)),hess)';
% L1=lik_GMM(Y,X,Z,x,para_fix,mmm,denominator,NWlags,para_estim)+prior(x,para_pri);
% den=den+min(exp(L1-m_lnL_lnp),1);
% end
% CJalt=m_lnL_lnp-log(num_alt/den)+mean(q/2);


% save in matrix
CJalt_s(count_s,count_m)=CJalt;
MCJalt_s(count_s,count_m)=CJalt-(1-1/sqrt(T))*(-negative_Lmode-prior(paramod,para_pri));

%% J statistics
J_s(count_s,count_m)=Jstat(1,count_s,mmm); % add 2017/12/3

count_s=count_s+1;
end %sample
count_m=count_m+1;
end %model


%% output
celltitle={'GNKPC','NKPC','GNKPC(w/oKappad)','GNKPC(w/oKappaf)','CS-GNKPC','CS-NKPC','CS-GNKPC(w/oKappad)','CS-GNKPC(w/oKappaf)'};
sampletitle={'period1','period2','period3','period4','period5'}';
t_label={'(a)','(b)','(c)','(d)','(e)','(f)','(g)','(h)'};

delete([pwd(),'\',today1,'\(output)',today,'_',num2str(num),'.txt'])
diary([pwd(),'\',today1,'\(output)',today,'_',num2str(num),'.txt'])
diary on

cc=1;
horizon_title={};
difference={};
d_LAP_s=[];
d_LAPp_s=[];
d_HM5_s=[];
d_HM9_s=[];
d_SWZ5_s=[];
d_SWZ9_s=[];
d_CJalt_s=[];
d_MLAP_s=[];
d_MLAPp_s=[];
d_MHM5_s=[];
d_MHM9_s=[];
d_MSWZ5_s=[];
d_MSWZ9_s=[];
d_MCJalt_s=[];
d_J_s=[]; % add 2017/12/3

for hh=m1:m2
    
    horizon_title=[horizon_title,[char(t_label(cc)),char(celltitle(hh))]];
    if cc>=2
        for cc2=1: cc-1 % set 'cc-1' if comparing every combination
            difference=[difference,[char(t_label(cc2)),'-',char(t_label(cc))]];
            d_LAP_s=[d_LAP_s,LAP_s(:,cc2)-LAP_s(:,cc)];
            d_LAPp_s=[d_LAPp_s,LAPp_s(:,cc2)-LAPp_s(:,cc)];
            d_HM5_s=[d_HM5_s,HM5_s(:,cc2)-HM5_s(:,cc)];
            d_HM9_s=[d_HM9_s,HM9_s(:,cc2)-HM9_s(:,cc)];
            d_SWZ5_s=[d_SWZ5_s,SWZ5_s(:,cc2)-SWZ5_s(:,cc)];
            d_SWZ9_s=[d_SWZ9_s,SWZ9_s(:,cc2)-SWZ9_s(:,cc)];
            d_CJalt_s=[d_CJalt_s,CJalt_s(:,cc2)-CJalt_s(:,cc)];    
            
            d_MLAP_s=[d_MLAP_s,MLAP_s(:,cc2)-MLAP_s(:,cc)];
            d_MLAPp_s=[d_MLAPp_s,MLAPp_s(:,cc2)-MLAPp_s(:,cc)];
            d_MHM5_s=[d_MHM5_s,MHM5_s(:,cc2)-MHM5_s(:,cc)];
            d_MHM9_s=[d_MHM9_s,MHM9_s(:,cc2)-MHM9_s(:,cc)];
            d_MSWZ5_s=[d_MSWZ5_s,MSWZ5_s(:,cc2)-MSWZ5_s(:,cc)];
            d_MSWZ9_s=[d_MSWZ9_s,MSWZ9_s(:,cc2)-MSWZ9_s(:,cc)];
            d_MCJalt_s=[d_MCJalt_s,MCJalt_s(:,cc2)-MCJalt_s(:,cc)];  
            
            d_J_s=[d_J_s,d_J_s,J_s(:,cc2)-J_s(:,cc)];
        end
    end
    cc=cc+1;
end

%% %%%%%%%%%%%%%%%%%%
% display posterior_mean
% %%%%%%%%%%%%%%%%%%%

prior_set2=prior_set;
if fullsamplemean==1
    prior_set2(3,3)={Y_fullsample*4};

end
    prior_set2(3,4)={para_pri(3,2)*4};
    
disp('<prior definition>')
[{'','estimated', 'distribution','mean','std'};[{'omega';'lambda';'pi';'theta';'alpha';'beta'},prior_set2]]
disp('* if estimated = 0, the corresponding parameter has not been estimated by MCMC:')
disp('  In this case, mean indicates the a fixed value for the parameter and std is dummy')

if not(fullsamplemean==1)
    disp('** prior mean of pi is dummy: a value used in estimation is a sample mean. ')
end
    
disp(' ')
disp('<sample period definition>')
names

IV2=strrep(IV,':,','');
IV2=strrep(IV2,'ones(length(Y),1)','const.');
disp('<Instruments>')
strrep(IV2,'_iv','')

varname={'400pi';'lambda';'omega';'theta';'alpha';'beta';'kappa';'gamma_b';'kappa_f';'kappa_d';'gamma_f'};
para_estim_extended=[para_estim0(3);para_estim0(2);para_estim0(1);para_estim0(4:6);ones(5,1)];

disp('<prior distribution of kappa etc.: mean>')
for nmodel=m1:m2
    temp3=[];
    temp3CI90=[];
    top_title={char(celltitle(nmodel)),'period1','period2','period3','period4','period5','period6','period7','period8'};
for tt=1:end_estim_period-start_estim_period+1
    temp2=num2cell(prior_mean(:,tt,nmodel));
    temp3=[temp3,temp2(size(prior_set,1)+1:size(prior_set,1)+5)];
end
    disp_pri_mean=[{'kappa','gamma_b','kappa_f','kappa_d','gamma_f'}',temp3];
    output_pri_mean=[[top_title(1,1),top_title(1,start_estim_period+1:end_estim_period+1)];disp_pri_mean]
end

% add 17/12/03
disp('<prior distribution of kappa etc.: standard deviation>')
for nmodel=m1:m2
    temp3std=[];
    temp3stdCI90=[];
    top_title={char(celltitle(nmodel)),'period1','period2','period3','period4','period5','period6','period7','period8'};
for tt=1:end_estim_period-start_estim_period+1
    temp2std=num2cell(prior_std(:,tt,nmodel));
    temp3std=[temp3std,temp2std(size(prior_set,1)+1:size(prior_set,1)+5)];
end
    disp_pri_std=[{'kappa','gamma_b','kappa_f','kappa_d','gamma_f'}',temp3std];
    output_pri_std=[[top_title(1,1),top_title(1,start_estim_period+1:end_estim_period+1)];disp_pri_std]
end
% end: add 17/12/03

disp('<estimation results>')
for nmodel=m1:m2
    para_estim2=para_estim_extended;
    if nmodel==2||nmodel==6
        para_estim2(4)=0;
    end
    temp3=[];
    temp3CI90=[];
    top_title={char(celltitle(nmodel)),'period1','period2','period3','period4','period5','period6','period7','period8'};

for tt=1:end_estim_period-start_estim_period+1
    temp2=num2cell(posterior_mean(:,tt,nmodel));
    temp2CI90=cellstr(num2str([posterior_CI90lower(:,tt,nmodel),posterior_CI90upper(:,tt,nmodel)]));
    temp3=[temp3,temp2(para_estim2==1)];
    temp3CI90=[temp3CI90,temp2CI90(para_estim2==1)];
end
    disp_post_mean=[varname(para_estim2==1),temp3];
    disp_post_CI90=[varname(para_estim2==1),temp3CI90];
    output_post_mean=[[top_title(1,1),top_title(1,start_estim_period+1:end_estim_period+1)];disp_post_mean]
    output_post_CI90=[[top_title(1,1),top_title(1,start_estim_period+1:end_estim_period+1)];disp_post_CI90]

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% display model selection results

disp('<Model Selection results>')
disp(' ')
disp('* Higher value indicates better model.')
disp(' ')

disp('Laplace estimator')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([LAPp_s,d_LAPp_s])]

disp('Harmonic mean estimator (tau=0.5)')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([HM5_s,d_HM5_s])]

disp('Harmonic mean estimator (tau=0.9)')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([HM9_s,d_HM9_s])]

disp('Sims-Waggoner-Zha estimator(tau=0.5)')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([SWZ5_s,d_SWZ5_s])]

disp('Sims-Waggoner-Zha estimator(tau=0.9)')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([SWZ9_s,d_SWZ9_s])]

disp('Chib-Jeliazkov estimator')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([CJalt_s,d_CJalt_s])]

% disp('MODIFIED Laplace estimator')
% 
% [' ', horizon_title, difference;
% sampletitle(s1:s2),num2cell([MLAP_s,d_MLAP_s])]

disp('MODIFIED Laplace estimator')

[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([MLAPp_s,d_MLAPp_s])]

disp('MODIFIED Harmonic mean estimator(tau=0.5)')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([MHM5_s,d_MHM5_s])]

disp('MODIFIED Harmonic mean estimator(tau=0.9)')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([MHM9_s,d_MHM9_s])]

disp('MODIFIED Sims-Waggoner-Zha estimator(tau=0.5)')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([MSWZ5_s,d_MSWZ5_s])]

disp('MODIFIED Sims-Waggoner-Zha estimator(tau=0.9)')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([MSWZ9_s,d_MSWZ9_s])]

disp('MODIFIED Chib-Jeliazkov estimator')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([MCJalt_s,d_MCJalt_s])]

disp('J statistics')
[' ', horizon_title, difference;
sampletitle(s1:s2),num2cell([J_s,d_J_s])]




disp([pwd(),'\',today1,'\',today,'_modelselect_',num2str(num),'.txt'])
diary off


