function [p]=prior(para,para_pri)

p=0;
 %omega - Beta distribution 
   p=log(betapdf2(para(1), para_pri(1,1),para_pri(1,2) ))+p;

 %lambda - Beta distribution 
   p=log(betapdf2(para(2), para_pri(2,1),para_pri(2,2) ))+p;

 %trend inflation - Normal distribution 
   p=log(normpdf(para(3),para_pri(3,1),para_pri(3,2) ))+p;


 end  

 % defining pdf function  
function [ Y ] = inversegampdf2( X,mu,se ) 
   A=mu^2/se^2+2; 
   B=mu*(A-1); 
   Y = (X>0)*B^A/gamma(A)*X.^(-A-1).*exp(-B./X); 
end 

function x=betapdf2(X,A,B) 
   a=A^2*(1-A)/B^2-A; 
   b=(1-A)/A*a; 
   x=betapdf(X,a,b); 
end 

function [x]=gampdf2(X,A,B) 
   a=A^2/B^2; 
   b=B^2/A; 
   x=gampdf(X,a,b); 
end 
